import { _decorator, Component, Label, Node } from 'cc';
import { attributes_data, event_item_text_sound, widget_item_data } from '../../../data/data';
import { Attributes } from '../Attributes';
import { config } from '../../config';
import { tools } from '../../tools';
import { ClientEvent } from '../../clientEvent';
const { ccclass, property } = _decorator;

@ccclass('event_text_sound')
export class event_text_sound extends Component {
    private m_data:event_item_text_sound = null;
    @property(Node) btn_select_ui:Node = null;
    @property(Node) lab_name:Node = null;
    public initView(data:event_item_text_sound){
        this.m_data = data;
        this.btn_select_ui.on(Node.EventType.TOUCH_END,()=>{
            let list =  Attributes.Singleton.get_cur_scene_widget_by_type(config.Widget_Type_List.TEXT_SOUND)
            if(list.length<=0){
                return tools.showToast("当前场景没有添加文本和音效！")
            }
            tools.show_select_widget_list(list,(item:widget_item_data)=>{
                this.m_data.binding_widget_id = item.att.id;
                this.updateStatus()
            },this.m_data.binding_widget_id)
          
        })
        this.updateStatus()
        ClientEvent.on(config.Event.UpdateAttributesToView,this.UpdateAttributesToView,this)
    }
    protected onDestroy(): void {
        ClientEvent.off(config.Event.UpdateAttributesToView,this.UpdateAttributesToView,this)
    }
    UpdateAttributesToView(data:attributes_data,update_type:string){
        if(this.m_data.binding_widget_id===data.id&&update_type===config.attributes_list_type.delete){
            this.m_data.binding_widget_id = -1;
            this.updateStatus()
        }
    }
    updateStatus(){
        this.lab_name.getComponent(Label).string =  this.m_data.binding_widget_id===-1?"添加文本和音效":`当前绑定的文本和音效id：${this.m_data.binding_widget_id}`
    }
}


